#pragma once 

struct TID_NODE
{
	int ntid;
	TID_NODE *pnext;
};

typedef struct FP_NODE
{
	int	frequency;
	int nchild_freq;
	int nitem_order;
	FP_NODE *pchild;
	FP_NODE	*prightsibling;
	FP_NODE *pparent;
	FP_NODE *pnode_link;
	TID_NODE* ptid_head;
	TID_NODE* ptid_tail;
	int* ptail_itemset;
} FP_NODE;

typedef struct
{
	int nitem; 
	int nsupport;
	FP_NODE *pconddb;
	TID_NODE *ptid_head;
	TID_NODE *ptid_tail;
	bool bgen_fullitems;
	bool bisclosed;
} HEADER_NODE;
typedef HEADER_NODE* HEADER_TABLE;

extern int *gplocal_item_sup_map;
extern int *gplocal_item_sumsup_map;


class FPtree
{
	void CountFreqItems(HEADER_TABLE pheader_table, int nitem_order, int *pitem_sup_map);
	FP_NODE* BuildNewTreeWTTail(FP_NODE *pconddb, HEADER_TABLE pnewheader_table, int *pitem_order_map);

	void countsup(FP_NODE *pfpnode);
	void countsup(FP_NODE *pfpnode, HEADER_TABLE phead_table, int num_of_freqitems);
	int CountTailFullItems(HEADER_TABLE phead_table, int ncur_order, int nfull_sup, int num_of_freqitems, int num_of_local_items);
	int GetTailFullItems(FP_NODE *pconddb, int nfull_sup, int nitem_order, int num_of_local_items);

	void PushRightTidList(FP_NODE *pconddb);
	int GetTidList(int support, FP_NODE *pcond_db, int *ptid_list);
	int GetTidList(int nitem, int support, FP_NODE *pcond_db, int* ptid_list);
	int GetTidList(int support, HEADER_NODE *pheader_node, int *ptid_list);

public:
	void InsertTransaction(FP_NODE* &proot, HEADER_TABLE pheader_table, int* ptransaction, int length, int nlast_item_pos, int frequency, TID_NODE *ptid_head, TID_NODE *ptid_tail);
	void TDBDepthFGGrowth(FP_NODE *proot, HEADER_TABLE pheader_table, int num_of_freqitems, int num_of_tail_items, int nend_pos);
	void GraphDepthFGGrowth(FP_NODE *proot, HEADER_TABLE pheader_table, int num_of_freqitems, int num_of_tail_items, int nend_pos);

};

extern FPtree goFPtree;
extern HEADER_TABLE gpheader_table;

int comp_item_freq_des(const void *e1, const void *e2);
int comp_hnode_freq_des(const void *e1, const void *e2);

extern int gncountsup_calls;
extern int gncounttail_calls;
extern double gdtail_count_time;