#pragma once 

#include <stdio.h>

#define ITEM_SUP_MAP_SIZE   1000

#define MAX_FILENAME_LEN	100
#define MAX(x,y)   (x>=y?x:y)
#define MIN(x,y)   (x<=y?x:y)


//parameter settings
extern char gszdata_filename[MAX_FILENAME_LEN];
extern int gntype;
extern int gnmin_sup;
extern int gnmin_size;
extern bool gbresult_name_given;
extern char gszresult_filename[MAX_FILENAME_LEN];

//some statistic information about the data
extern int gndb_size;
extern int gnmax_trans_len;
extern int gnmax_item_id;

//pattern statistics
extern int gntotal_freqitems;
extern int gnmax_pattern_len;
extern int gntotal_closed;
extern int gntotal_bipartite;

//time statistics
extern double gdtotal_running_time;

//space statistics
extern double gdused_mem_size;
extern double gdmax_used_mem_size;
extern int gntree_init_size;
extern int gntree_max_size;

//program running statistics
extern int gntotal_call;


int comp_int_asc(const void *e1, const void *e2);

//global varibles
extern int *gpprefix_itemset;
extern int gnprefix_len;


extern int *gptransaction;
extern char *gpsort_trans_buf;
extern int gnum_of_newfreqitems;

extern int *gpdfs_item_suporder_map;
extern int *gpdfs_cofreqs;
extern int *gpdfs_pruned_items;
extern int *gpitem_sup_map;

extern int *gpitem_order_map;
extern int gnfirstitem_order;
extern int gnfirstitem_pos;


struct ITEM_COUNTER
{
	int nitem;
	int norder;
	int nsupport;
};

extern ITEM_COUNTER *gpdfs_item_counter;

void MineBP_TDB();
void MineBP_Graph();


extern int *gptid_list;
