#pragma once 

#include <stdio.h>
#include <stdlib.h>

#include "Global.h"	
#include "FPtree.h"

#define PAGE_SIZE 4096
typedef struct
{
	int *phead;
	int *ptail;
	int npos;
	int num_of_pages;
} DB_HEAD_NODE;

struct TRANS_NODE
{
	int ntid;
	int length;
	int* pitemset;
};

class CScanDBMine
{
	int *mpgraph, mngraph_size;
	int** mppadj_lists;
	int mnpage_capacity;
	int mninit_pruned_items, mnpruned_items;

	void InsertOneTrans(int ntrans_no, int* ptransaction, int length);

public:
	int ScanDBCountFreqItems(int* &pitem_sup_map);
	FP_NODE* ScanDBBuildFPtree(HEADER_TABLE pheader_table, int *pitem_order_map);
	int ScanDBGetTidList(int nitem, int* ptid_list);

	int ScanGraphCountFreqVertices(int* &pitem_sup_map);
	int ScanGraphGetTidList(int nvertex, int* ptid_list);

	void LoadDB(int* pitem_sup_map, int nsup_sum);
	void DestroyDB();

	void PrintSum(FILE *fp);

};

extern CScanDBMine  goDBMiner;


