#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#include <crtdbg.h>

#include <string.h>
#include <time.h>
#include <sys/timeb.h>

#include "ScanDBMine.h"
#include "FPtree.h"
#include "fsout.h"
#include "data.h"
#include "inline_routine.h"


HEADER_TABLE gpheader_table;
HEADER_TABLE gpdfs_header_array;
int gndfs_header_size;
int gndfs_header_pos;


void PrintSummary();


int main(int argc, char *argv[])
{
	int narg_no;

	if(argc!=5 && argc!=6)
	{
		printf("Usage\n");
		printf("\t%s  data_filename data_type nmin_sup  nmin_size [output_filename]\n", argv[0]);
		return 0;
	}	

	narg_no = 1;
	strcpy(gszdata_filename, argv[narg_no]);
	narg_no++;

	gntype = atoi(argv[narg_no]);
	narg_no++;

	gnmin_sup = atoi(argv[narg_no]);
	narg_no++;
	if(gnmin_sup<1)
	{
		printf("Please specify a native number for the minimum support threshold\n");
		return 0;
	}

	gnmin_size = atoi(argv[narg_no]);
	narg_no++;
	if(gnmin_size<1)
	{
		printf("Please specify a native number for the minimum support threshold\n");
		return 0;
	}

	if(argc==narg_no+1)
	{
		gbresult_name_given = true;
		strcpy(gszresult_filename, argv[narg_no]);
	}
	else 
		gbresult_name_given = false;

	if(gntype==0)
		MineBP_TDB();
	else 
		MineBP_Graph();

	PrintSummary();

	_CrtDumpMemoryLeaks();

	return gntotal_bipartite;
}


void PrintSummary()
{
	printf("#closed itemsets: %d\n", gntotal_closed);
	printf("#Bipartites: %d\n", gntotal_bipartite);

	if(gdused_mem_size!=0)
		printf("Error with memory: %.2f are not released\n", gdused_mem_size);

	FILE *fp_sum;

	fp_sum = fopen("bplarge.sum.txt", "a+");
	if(fp_sum == NULL)
	{
		printf("Error[PrintSummary]: cannot open file fg.sum.txt\n");
		return;
	}
	fprintf(fp_sum, "MineBP-fp %s ", gszdata_filename);
	fprintf(fp_sum, "%d %d ", gnmin_sup, gnmin_size);
	fprintf(fp_sum, "%d %d %d\t", gnmax_pattern_len, gntotal_closed, gntotal_bipartite);
	fprintf(fp_sum, "%.2f %d\t", gdtotal_running_time, gntotal_call);
	fprintf(fp_sum, "%.2fMB %.2fMB %.2fMB\t", gdmax_used_mem_size/(1<<20), (double)gntree_init_size/(1<<20), (double)gntree_max_size/(1<<20));

	//goDBMiner.PrintSum(fp_sum);

	fprintf(fp_sum, "%d %.2fMB\t", gntail_buf_pages, (double)gntail_buf_size/(1<<20));
	fprintf(fp_sum, "%.2f %d %d\t", gdtail_count_time, gncounttail_calls, gncountsup_calls);

	fprintf(fp_sum, "\n");
	fclose(fp_sum);

}

